use crate::sys;
use std::ffi::CString;
use std::os::raw::c_char;

pub use crate::sys::ImPlotPoint;

pub struct PlotLine {
	label: CString,
}

impl PlotLine {
	pub fn new(label: &str) -> Self {
		Self {
			label: CString::new(label)
				.unwrap_or_else(|_| panic!("label string has internal null bytes: {}", label)),
		}
	}

	pub fn plot(&self, x: &[f64], y: &[f64]) {
		if x.len().min(y.len()) == 0 {
			return;
		}

		unsafe {
			sys::ImPlot_PlotLine_doublePtrdoublePtr(
				self.label.as_ptr() as *const c_char,
				x.as_ptr(),
				y.as_ptr(),
				x.len().min(y.len()) as i32,
				0,
				0,
				std::mem::size_of::<f64>() as i32,
			);
		}
	}
}
